{-# LANGUAGE TypeApplications #-}

module Test.Core.LinearAlgebra where

import Prelude
import Test.Tasty.QuickCheck
import Gargantext.Core.LinearAlgebra qualified as LA
import Test.Tasty
import Gargantext.Core.Viz.Graph.Index qualified as Legacy
import Data.Map.Strict (Map)
import Data.Map.Strict qualified as M

compareImplementations :: (Arbitrary a, Eq b, Show b)
                       => (a -> b)
                       -> (a -> c)
                       -> (c -> b)
                       -> a
                       -> Property
compareImplementations implementation1 implementation2 mapResults inputData
  = implementation1 inputData === mapResults (implementation2 inputData)

mapCreateIndices :: (Map t Legacy.Index, Map Legacy.Index t) -> (Map t LA.Index, Map LA.Index t)
mapCreateIndices (m1, m2) = (M.map LA.Index m1, M.mapKeys LA.Index m2)

tests :: TestTree
tests = testGroup "LinearAlgebra" [
    testProperty "createIndices roundtrip" (compareImplementations (LA.createIndices @Int @Int) Legacy.createIndices mapCreateIndices)
    ]
